program _Export;

Uses
 Palette,Sprites;

Type
 BMP256=Record

  bfType:array[1..2] of char;
  bfSize:LongInt;
  brReserved:LongInt;
  bgOffBits:LongInt;

  biSize:LongInt;
  biWidth:LongInt;
  biHeight:LongInt;
  biPlanes:word;
  biBitCount:word;
  biCompression:longint;
  biSizeImage:longint;
  biXPelsPerMeter:longint;
  biYPelsPerMeter:longint;
  biClrUsed:Longint;
  biClrImportant:longint;

  WinPal:array[0..255,0..3] of byte;

 end;


procedure SaveBitmap;
 Var
  f:file;
  Header:BMP256;
  x,y:integer;
 begin
  Assign(f,'SPRITES.BMP');
  Rewrite(f,1);
  Header.bfType:='BM';
  Header.bfSize:=320*200+SizeOf(Header);
  Header.brReserved:=0;
  Header.bgOffBits:=SizeOf(Header);
  Header.biSize:=40; { ??? }
  Header.biWidth:=320;
  Header.biHeight:=200;
  Header.biPlanes:=1;
  Header.biBitCount:=8;
  Header.biCompression:=0;
  Header.biSizeImage:=320*200;
  Header.biXPelsPerMeter:=3790; { ?? }
  Header.biYPelsPerMeter:=3800;
  Header.biClrUsed:=256;
  Header.biClrImportant:=0;
  for x:=0 to 255 do begin
   Header.WinPal[x,0]:=Colors[x,2] shl 2;
   Header.WinPal[x,1]:=Colors[x,1] shl 2;
   Header.WinPal[x,2]:=Colors[x,0] shl 2;
   Header.WinPal[x,3]:=0;
  end;
  BlockWrite(f,Header,SizeOf(Header));
  for y:=199 downto 0 do BlockWrite(f,Mem[SegA000+20*y:0],320);
  Close(f);
 end;

var
 s:integer;
 x,y:integer;
begin
 LoadSpriteLib('SPRITELI.DAT');
 x:=0;
 y:=0;

 for s:=0 to SpriteCount-1 do begin
  DrawSprite(s,x,y);
  inc(x,16);
  if x>320 then begin
   x:=0;
   inc(y,16);
   if y>200 then break;
  end;
 end;

 SaveBitmap;
end.

